#!/bin/sh
#
# Component: cases
#
# Description:
#
# Usage:
#   checkLockedUsers
#
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

if [ -f $CONF/lockusers.conf ] ; then
	. $CONF/lockusers.conf
else
	if [ -f $CASES_HOME/cfg/lockusers.conf ] ; then
		. $CASES_HOME/cfg/lockusers.conf
	else
			echo "no config file!"
			exit 1	
	fi
fi

echo "keeplogins:$keeplogins"
if [ ! -z "$keeplogins" ] ; then
	now=`date +%s`
	echo "now:"$now
	update="delete from FailedLogin where $now>=FLEVENTDATETIME+($keeplogins*86400)"
	echo "$update"
	echo $update | $MYSQL_HOME/bin/mysql -N $DBNAME
fi