<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: dotcom
 *
 * Description:
 *     Draws diagram of devices connected to a given dotcom device.
 *
 * @param cDevice : ID of the dotcom device to write the diagram for
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@
	page import="imagemed.imsession.*, imagemed.util.*, imagemed.dotcom.*, java.util.*, java.io.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession(request, response, out);
	is.bRegNotNeeded = false;
	is.bCheckHttpsAndRedirect = false;

	String prDevice = request.getParameter("cDevice");
	String parDevice = prDevice.replaceAll("-", "_dash_");
	
	prDevice = prDevice.replaceAll("_dash_", "-");
	//decoded
	
%><HTML><HEAD><TITLE>Devices connected to <%=parDevice%></TITLE></HEAD><BODY><PRE>

<%	

	Map<String, Properties> devIfaces = new Hashtable<String, Properties>();
	String selfId = DotcomConfig.selfId();
	
	int counter = 0;

	FileWriter fileWriter = new FileWriter(IMEnvBase.getEnv("TMP") + "/twopigraph-" + parDevice + ".dot");
	fileWriter.write("graph tdotcom {\n");
	fileWriter.write("ranksep = 2.5\n");

	String filledAttr = (prDevice.equals(selfId)) ? "style = filled, fillcolor = lightgrey, " : "";
	fileWriter.write(parDevice + " [shape = record, color = black, " + filledAttr + "label = \"<f0> " + parDevice + " \"]\n");

	DotcomDevice dotcomDevice = DotcomConfig.getConfig().getDevice(prDevice);

	Set<DeviceInterface> interfaces = dotcomDevice.getInterfaces(); 
	for (Iterator<DeviceInterface> f = interfaces.iterator() ; f.hasNext() ; ) {
		DeviceInterface g = f.next();

		String ifaceDevice = g.getDevice();
		String gDev = g.getId();
		String gDevice = gDev.replaceAll("-", "_dash_");

		Properties prpIfaces = devIfaces.get(ifaceDevice);
		if (prpIfaces == null) {
			prpIfaces = new Properties();
			devIfaces.put(ifaceDevice, prpIfaces);
		}

		String ipPort = g.getIp() + ":" + g.getPort();
		String field = prpIfaces.getProperty(ipPort);
		
		String ae = (g instanceof DicomInterface) ? ((DicomInterface) g).getAETitle() : "";

		if (field == null) {
			counter++;
			field = "f" + counter;
			prpIfaces.setProperty(ipPort, field);
		}

		fileWriter.write(parDevice + " -- \"" + gDevice + "\":" + field + " [color = grey]\n");
		
		fileWriter.write(gDevice + " [shape = record, color = grey, label = \"{<f0> " + gDevice + " ");
		if (prpIfaces !=null) {
			for (Enumeration<?> ff = prpIfaces.propertyNames() ; ff.hasMoreElements() ;) {
				String ipPort2 = (String) ff.nextElement(); 
				String fieldId = prpIfaces.getProperty(ipPort);
				fileWriter.write("|<" + fieldId + "> " + ipPort2 + " \\n" + ae);
			}
		}
		fileWriter.write("}\"]\n");
	}

	fileWriter.write("}\n");
	fileWriter.close();
	
	String cmd[] = new String[6];
	cmd[0] = "twopi";
	cmd[1] = "-T";
	cmd[2] = "png";
	cmd[3] = "-o";
	cmd[4] = IMEnvBase.getEnv("MAIN_DATA") + "/twopigraph-" + parDevice + ".png";
	cmd[5] = IMEnvBase.getEnv("TMP") + "/twopigraph-" + parDevice + ".dot";

	Helper.runCommand(cmd, null);
%>
</PRE>

<IMG SRC="/main/data/twopigraph-<%=parDevice%>.png">

</BODY></HTML>
--%>