#!/bin/sh
# Component: dotcom
#
# Description:
#   Sync all study.
#
# Usage:
#    syncAll.sh 
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh
. $HOME/component/tools/scripttools.shi

[ -f "$CONF/serverid.cfg" ] && . "$CONF/serverid.cfg"
JOB_ID="$SELF_SERVER_ID-SYNC$(date +%s)"

echo "select STYIUID from Dcstudy" | ~/component/mysql/bin/mysql -N imagemedical | \
while read study; do
	niceme && break

	$TASKD_HOME/createtaskfileapp -p "STUDY_SYNCHRONIZER" -j "$JOB_ID" -t "class" -c "dotcom.StudySynchronizerTask -f -s \"$study\""
done

