<%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="java.io.*, java.util.*, java.text.*,
			com.erad.pacs.modules.gwt.descriptors.usermanager.SessionInfo,
			com.erad.pacs.modules.gwt.session.BrowserInfo,
			com.erad.pacs.connector.Connector,
			com.erad.pacs.services.usermanager.client.Session,
			com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
			com.erad.pacs.toolbox.MahagoniToolbox,
			imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*,
			imagemed.layout.*, imagemed.layout.cache.*, imagemed.layout.validator.*,
			imagemed.types.*, imagemed.types.enumeration.*, imagemed.exception.*,
			imagemed.users.UserFile"

%><%-- -----INIT & PROCESS---- --%><%

	/*		possible values of op:
	 *			restore: 	the user-defined default XML will be erased
	 *			upload:		a new user-defined default XML will be uploaded
	 * 		optional parameter: cUser to identify who's personal default to set/restore...
	 */

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );
	String errorMessage = null;

	MultipartRequest req = new MultipartRequest(request, IMEnvBase.getEnv( "TMP" ) );
	String layoutType = request.getParameter( "cLayoutType" );
	if (layoutType == null )
		layoutType = LayoutPart.REPORTLAYOUT;
	String parUser = request.getParameter("cUser");
	String parGroup = request.getParameter("cGroup");
	if (parUser == null || parUser.equals("")) {
		parUser = sess.getUser().getUserId( );
	}
	if (parGroup == null || parGroup.equals("")) {
		parGroup = IMAdminToolbox.getUserGroup(parUser);
	}
	try {
		if (LayoutXmlToolbox.checkAndDoOper( sess , response, request, req)) {
			return;
		}
	} catch (IMGeneralException ex){
		errorMessage = ex.getHtmlMessage();
	}
	String error = request.getParameter( "error" );
	if ("validator".equals( error)){
		errorMessage = new IMGeneralException( "Missing parameter: No valid validator selected!", "imadmin/dicomsrv.jsp", "Upload failed", "/imadmin/reportXML.jsp" ).getHtmlMessage();
	}
	
%><%-- -----HTML---- --%><HTML>
<!--<%=Helper.request2String(request)%>-->
<HEAD><TITLE><%=LocalizedMessage.getCompoundMessage( "IMADMIN_REPORTXML_HTMLPAGE_TITLE", new Format[] { null }, new Object[] { layoutType }, true)%></TITLE>
<%
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(response.getWriter());
%>
	<script language="JavaScript">
		function doUpload() {
			var frm = self.document.uploadForm;
			while (frm.cFileName.value != frm.New.value) {
				frm.cFileName.value = frm.New.value;
			}
			frm.submit();
		}
		
		function doUploadImage() {
			var frm = self.document.uploadImageForm;
			while (frm.cImageName.value != frm.New.value) {
				frm.cImageName.value = frm.New.value;
			}
			frm.submit();
		}
		
		function doUploadValidator() {
			var frm = self.document.uploadValidatorForm;
			while (frm.cValidatorName.value != frm.New.value) {
				frm.cValidatorName.value = frm.New.value;
			}
			frm.submit();
		}
		
		function doRefresh() {
			var frm0 = self.document.editReportForm;
			var frm = self.document.refreshForm;
			while (frm.cSelectedXml.value != frm0.cFileName.value) {
				frm.cSelectedXml.value = frm0.cFileName.value;
			}
			frm.submit();
		}
		
		function exportValidator() {
			var frm = self.document.validatorForm;
			var validator = frm.cValidatorName.value;
			var url = "/imadmin/getValidator.jsp?cLayoutType=<%=layoutType%>&cValidatorName="+escape(validator);
			document.location.href=url;
		}

		function exportImage() {
			var frm = self.document.imageForm;
			var image = frm.cImageName.value;
//			var url = "/cases/showattachment.jsp?cExport=true&cFileName="+escape(image);
			var url = "/attachment/"+escape(image);
			document.location.href=url;
		}
		
		function doReload() {
			var frm0 = self.document.userReportForm;
			var frm = self.document.refreshForm2;
			while (frm.cUser.value != frm0.cUser.value) {
				frm.cUser.value = frm0.cUser.value;
			}
			frm.submit();
		}
				
		function doReload2() {
			var frm0 = self.document.groupReportForm;
			var frm = self.document.refreshForm3;
			while (frm.cGroup.value != frm0.cGroup.value) {
				frm.cGroup.value = frm0.cGroup.value;
			}
			frm.submit();
		}
				
	</script>
</HEAD>
<BODY>
<%
	//TabToolbox.makeTabs( is, is.tabbean, "imadmin/dicomsrv.jsp", "White");

	if (!sess.getRights().hasAdminRight()) { //Has no ADMIN RIGHT?
%>
    <BR>
    <CENTER><H3>
      <%=LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" )%>
    </H3></CENTER></BODY></HTML>
<%
		return;
	}

	if (errorMessage != null){
		out.print( errorMessage);
		return;
	}

	LayoutXmlToolbox.handleCopySettings( sess, request.getParameterMap() );
	UserFile xmlTmpFile = LayoutCache.getUserTmpLayoutXmlFile( layoutType, sess.getUser().getUserId() );

%>
<table></table>                           
  <CENTER>
<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=0 WIDTH=100% class=BgShadow>
<tr>
	<td>
		<table CELLPADDING=0 CELLSPACING=0 WIDTH=100%>
			<tr>
				<td valign=center>
					<BR><nobr>&nbsp;&nbsp;
					<font size="4">
						<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_TITLE" )%>
				&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_LAYOUT_TYPE" )%>: <select name="selLayoutType" onchange='l=options[selectedIndex].value; document.location.href="/imadmin/reportXML.jsp?cLayoutType=" + l;'>
				<%
					// we want to sort the types according to their localized names (and also have the names in the same order)
				
					String[] localizedNames = new String[ LayoutPart.LAYOUTTYPES.size() ];
					Properties localNamesTypes = new Properties();
					for (int i=0; i<LayoutPart.LAYOUTTYPES.size(); i++) {
						String local = LocalizedMessage.getSimpleMessage( LayoutPart.LAYOUTTYPENAMES.get(i) );
						localizedNames[ i ] = local;
						localNamesTypes.setProperty( local, LayoutPart.LAYOUTTYPES.get(i) );
					}
					localizedNames = Helper.sortCaseInSensitive( localizedNames );
					
					for (int i=0; i < localizedNames.length; i++) {
							String currentOne = localNamesTypes.getProperty( localizedNames[ i ] );
							String selected = currentOne.equals(layoutType)?" selected=\"selected\"":"";
							if (! new File(LayoutCache.getBuiltinXmlFileName(currentOne)).exists()) {
								// skip layouts that don't have default template
								continue;
							}
				%>
						<option value="<%=currentOne%>" <%=selected%>><%=localizedNames[ i ]%>
				<%
					}
				%>
				</select></nobr>
					</font>
					<BR>&nbsp;
				</td>
				<td align=right valign=center>
				</td>
			</tr>
		</table>
	</td>
</tr>
</table>
<TABLE CELLPADDING=0 CELLSPACING=0 WIDTH=100% class=BgShadow>
<TR>
	<TD align=center valign=middle height=18>
		<table border=1 CELLPADDING=0 CELLSPACING=0 WIDTH=100%>
			<tr>
				<td width="15%" valign=center>
			  	<br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_UPLOAD_XML" )%>: <br>&nbsp;
			  </td>
		  	<%=LayoutXmlToolbox.getUploadFormTD(new BrowserInfo(), layoutType, "  ")%>
			  <td>&nbsp;</td>
  		</tr>
<%
	String selectedXml = request.getParameter("cSelectedXml");
	if (selectedXml == null) {
		selectedXml = LayoutXmlToolbox.getLatestXml(sess, layoutType);
	}
	if (selectedXml == null) {
		selectedXml = LayoutXmlToolbox.BUILTIN;
	}
	// edit/export/delete selector
	String xmlCombo = LayoutXmlToolbox.getSystemXmlComboBox(sess, layoutType, "          ", true, selectedXml);
	boolean isReferenceSelected = xmlCombo.indexOf("@\" selected>") > 0;
%>
			<tr>
				<td width="15%" valign=center nowrap>
				  <br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_EXISTING_XML" )%>: <br>&nbsp;
				</td>
				<form name="editReportForm" method=post action="editReportXml.jsp">
					<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
					<td valign=center nowrap>
						<%=xmlCombo%>&nbsp;
					</td>
					<td valign=center nowrap>
						<%=JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_EDIT", "cOp", "open")%>&nbsp;&nbsp;&nbsp;
						<a href="getXML.jsp?cTemplate=<%=selectedXml%>&cLayoutType=<%=layoutType%>" onMouseOver="ws('Download XML file'); return true;">
							<%=JSHelper.getJsLocalizedButton( "BUTTON_EXPORT", "BUTTON_NULL", false )%>
						</a>&nbsp;&nbsp;&nbsp;
						
				    <%=isReferenceSelected?"":JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_DELETE", "cOp", "deleteXml")%>
					</td>
				</form>
				<td valign=center nowrap>
					<a href="editReportXml.jsp?cOp=new&cLayoutType=<%=layoutType%>" onMouseOver="ws('Create and edit new XML');return true;">
					  <%=JSHelper.getJsLocalizedButton( "BUTTON_NEW_REPORT", "BUTTON_NEW_REPORT_TITLE", false )%>
					</a>
<%
	if ( xmlTmpFile.exists() ) {
%>
					&nbsp;&nbsp;&nbsp;
  				<a href="editReportXml.jsp?cLayoutType=<%=layoutType%>" onMouseOver="ws('Go on with latest edit session');return true;">
				  	<%=JSHelper.getJsLocalizedButton( "BUTTON_CONTINUE", "BUTTON_CONTINUE_LATEST_EDIT_TITLE", false )%>
				  </a>
<%
	}
%>
				</td>
  		</tr>
<%
	// System default selection
	String currentDefault = LayoutCache.getUserLayoutXmlName(layoutType, SessionInfo.SYSTEM_USERID);
	xmlCombo = LayoutXmlToolbox.getSystemXmlComboBox(sess, layoutType, "          ", false, currentDefault);
	boolean isEmpty = (xmlCombo == null);
	if (!isEmpty) {
%>
			<tr>
				<td valign=center nowrap>
				  <br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_SYSTEM_TEMPLATE" )%>: <br>&nbsp;
				</td>
				<form method=post action="reportXML.jsp">
					<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
					<td valign=center nowrap>
						<table cellpadding=0 cellspacing=0>
							<tr>
								<td nowrap>
									<%=xmlCombo%>&nbsp;
								</td>
								<td width=100% style="text-align: right">
									<%=LayoutXmlToolbox.getCopySettingTD(layoutType, LayoutXmlToolbox.SYSTEMSETTING, null)%>
								</td>
							</tr>
						</table>
					</td>
					<td valign=center nowrap>
						<input type=hidden name="op" value="default">
				    <%=JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_SET_AS_DEFAULT", "", "" )%>
					</td>
				</form>
				<td>&nbsp;</td>
			</tr>
<%
	}
	// Group default selection
	xmlCombo = LayoutXmlToolbox.getGroupXmlComboBox(sess, layoutType, "          ", false, LayoutCache.getUserLayoutXmlName(layoutType, "#"+parGroup));
	if (!isEmpty) {
%>
			<tr>
				<td valign=center nowrap>
				  <br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_GROUP_TEMPLATE" )%>: <br>&nbsp;
				</td>
				<form name="groupReportForm" method=post action="reportXML.jsp">
					<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
					<td valign=center nowrap>
<%
	
%>
						<table cellpadding=0 cellspacing=0>
							<tr>
								<td nowrap>
									<%=xmlCombo%>
								</td>
								<td nowrap>
<%
	String[] groups = ((IMTypegr) IMType.getTypeFor("gr")).enumValues();
%>
						&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_GROUP" )%>:&nbsp;
						<select name="cGroup" onChange="doReload2()">
<%
	for (String group :groups) {
		if(group.equals("Everyone"))continue;//CBT #3947
	String selectedTag = (group.equals(parGroup)?" selected":"");
%>
							<option value="<%=group%>"<%=selectedTag%>><%=group%>
<%
	}
%>
						</select>
					</td>
					<td width=100% style="text-align: right">
					<%=LayoutXmlToolbox.getCopySettingTD(layoutType, LayoutXmlToolbox.GROUPSETTING, parGroup)%>
					</td>
							</tr>
						</table>
					</td>
					<td valign=center nowrap>
						<input type=hidden name="op" value="default">
				    <%=JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_SET_AS_DEFAULT", "", "" )%>
					</td>
				</form>
				<td>&nbsp;</td>
			</tr>
<%
	}
	// User default selection
	xmlCombo = LayoutXmlToolbox.getUserXmlComboBox(sess, layoutType, "          ", false, LayoutCache.getUserLayoutXmlName(layoutType, parUser));
	if (!isEmpty) {
%>
			<tr>
				<td valign=center nowrap>
				  <br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_USER_TEMPLATE" )%>: <br>&nbsp;
				</td>
				<form name="userReportForm" method=post action="reportXML.jsp">
					<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
					<td valign=center nowrap>
<%
	
%>
						<table cellpadding=0 cellspacing=0 width=100%>
							<tr>
								<td nowrap>
									<%=xmlCombo%>
								</td>
								<td nowrap>
<%
	List<String> users = FolderToolbox.getAllUsers( false );
%>
						&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_USER" )%>:&nbsp;
						<select name="cUser" onChange="doReload()">
<%
	for (int i=0; i<users.size(); i++) {
	String user = users.get(i);
	String selectedTag = (user.equals(parUser)?" selected":"");
%>
							<option value="<%=user%>"<%=selectedTag%>><%=user%>
<%
	}
%>
						</select>
					</td>
					<td width=100% style="text-align: right">
					<%=LayoutXmlToolbox.getCopySettingTD(layoutType, LayoutXmlToolbox.USERSETTING, parUser)%>
					</td>
							</tr>
						</table>
					</td>
					<td valign=center nowrap>
						<input type=hidden name="op" value="default">
				    <%=JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_SET_AS_DEFAULT", "", "")%>
					</td>
				</form>
				<td>&nbsp;</td>
			</tr>
<%
	}
	String imageCombo = LayoutXmlToolbox.getImageComboBox(sess, "          ");
	isEmpty = (imageCombo == null);
%>
			<tr>
				<td valign=center nowrap>
				  <br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_DOCUMENT_SERVER" )%>: <br>&nbsp;
				</td>
<%
	if (isEmpty) {
%>
				<td>&nbsp;</td><td>&nbsp;</td>
<%
	}
	else {
%>
				<form name="imageForm" method=post action="reportXML.jsp">
					<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
					<td valign=center nowrap>
						<input type=hidden name="op" value="delImage">
						<%=imageCombo%>&nbsp;
					</td>
					<td valign=center nowrap>
						<a href="javascript:exportImage()">
							<%=JSHelper.getJsLocalizedButton( "BUTTON_EXPORT", "BUTTON_NULL", false )%>
						</a>&nbsp;&nbsp;&nbsp;
						<%=JSHelper.getJsInputLocalizedButton( new BrowserInfo(), "BUTTON_DELETE", "", "")%>
					</td>
				</form>
<%
	}
%>
		  	<%=LayoutXmlToolbox.getUploadImageFormTD(new BrowserInfo(), layoutType, "  ")%>
			</tr>


<%
	String validatorCombo = LayoutXmlToolbox.getValidatorComboBox(sess, layoutType, "          ");
%>
			<tr>
				<td valign=center nowrap>
				  <br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_VALIDATORS_SERVER" )%>: <br>&nbsp;
				</td>
				<form name="validatorForm" method=post action="reportXML.jsp">
					<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
					<td valign=center nowrap>
						<%=validatorCombo%>&nbsp;
					</td>
					<td valign=center nowrap>
						<a href="javascript:exportValidator()">
							<%=JSHelper.getJsLocalizedButton( "BUTTON_EXPORT", "BUTTON_NULL", false )%>
						</a>&nbsp;&nbsp;&nbsp;
					<input type="hidden" name="validatorOp" value="delete">
						<a href=javascript:document.validatorForm.submit()><%=JSHelper.getJsLocalizedButton( "BUTTON_DELETE", "BUTTON_NULL", false )%></a>
					</td>
				</form>
		  	<%=LayoutXmlToolbox.getUploadValidatorFormTD(sess, layoutType, "  ")%>
			</tr>



<%
	isEmpty = LayoutXmlToolbox.listFileNames(Validator.getValidatorDir(layoutType), ".class").isEmpty();

if (!isEmpty) {
%>
			<tr>
				<td valign=center nowrap>
				  <br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_SYSTEM_VALIDATOR" )%>: <br>&nbsp;
				</td>
				<form name="systemValidatorForm" method=post action="reportXML.jsp">
					<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
					<input type="hidden" name="cValUser" value="<%= SessionInfo.SYSTEM_USERID %>">
					<td valign=center nowrap>
						<%=LayoutXmlToolbox.getValidatorSelectorComboBox(sess, layoutType, "						", false)%>&nbsp;
					</td>
					<td valign=center nowrap>
						<input type=hidden name="validatorOp" value="default">
				    <a href=javascript:document.systemValidatorForm.submit()><%=JSHelper.getJsLocalizedButton( "BUTTON_SET_AS_DEFAULT", "BUTTON_NULL", false )%></a>
					</td>
				</form>
				<td>&nbsp;</td>
			</tr>
			<tr>
				<td valign=center nowrap>
				  <br>&nbsp;&nbsp;<%=LocalizedMessage.getSimpleMessage( "IMADMIN_REPORTXML_USER_VALIDATOR" )%>: <br>&nbsp;
				</td>
				<form name="userValidatorForm" method=post action="reportXML.jsp">
					<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
					<input type="hidden" name="cValUser" value="<%= sess.getUser().getUserId() %>">
					<td valign=center nowrap>
						<%=LayoutXmlToolbox.getValidatorSelectorComboBox(sess, layoutType, "						", true)%>
					</td>
					<td valign=center nowrap>
						<input type=hidden name="validatorOp" value="default">
				    <a href=javascript:document.userValidatorForm.submit()><%= JSHelper.getJsLocalizedButton( "BUTTON_SET_AS_DEFAULT", "BUTTON_NULL", false ) %></a>
					</td>
				</form>
				<td>&nbsp;</td>
			</tr>

<%} %>
		</table>
	</td>
</tr>
</table>
</CENTER>
<form name="refreshForm" method=get action="reportXML.jsp">
	<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
	<input type=hidden name="cSelectedXml" value="">
</form>
<form name="refreshForm2" method=get action="reportXML.jsp">
	<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
	<input type=hidden name="cUser" value="">
</form>
<form name="refreshForm3" method=get action="reportXML.jsp">
	<input type="hidden" name="cLayoutType" value="<%=layoutType%>">
	<input type=hidden name="cGroup" value="">
</form>
</BODY>
</HTML>
