<%--
 * Component: cases
 *
 * Description:
 *    Get License Request
 *
 * Parameters:
 *		cType					: type of the request, may be 'license', 'extension' or 'change'
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@ page trimDirectiveWhitespaces="true" %>
<%@
  page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.http.Range, imagemed.license.*, org.w3c.dom.Document, javax.xml.parsers.*, 
	imagemed.imsession.*,imagemed.util.*, imagemed.jsputil.*,java.io.File,imagemed.exception.*"
%><%
	String type = request.getParameter( "cType" );
  
	String tmpFileName = eRADLicenseRequest.TMP_FILENAME_ON_SERVER + Helper.getCounter(  ) + ".xml";
	eRADLicenseRequest licreq = new eRADLicenseRequest( type );
	licreq.createXML( tmpFileName );
		
	if( eRADLicenseRequest.VALUE_CHANGE.equals( type ) ) {
		// change request is: request + last original or change license, in 1 file, with separator
		Helper.appendTextFile( tmpFileName, eRADLicense.SEPARATOR );
		String lastlic = LicenseToolbox.getLastLicenseName( false );
		if( lastlic == null ) {
			throw new IMGeneralException( "Couldn't find license file for the change", "imadmin/srvinfo.jsp", "License request generation failed", "/imadmin/srvinfo.jsp" );
		}
		Helper.appendTextFile( tmpFileName, Helper.readTextFile( lastlic ) );
	}
	
  try {
		response.setContentType( "application/octet-stream" );
		String savename = eRADLicenseRequest.SAVENAME_LICENSE;
		if( eRADLicenseRequest.VALUE_EXTENSION.equals( type ) ) {
			savename = eRADLicenseRequest.SAVENAME_EXTENSION;
		}
		else if( eRADLicenseRequest.VALUE_CHANGE.equals( type ) ) {
			savename = eRADLicenseRequest.SAVENAME_CHANGE;
		}
		response.setHeader("Content-Disposition", "attachment; filename=" + savename );
		
		Range range = new Range( request, response );
	
		range.sendRequestedRange( tmpFileName );
	}
	catch( Throwable t1 ) {
		// not found or other I/O error
	
		//response.setStatus(404);
		response.setHeader("Content-type","text/html");
		String msg = "<HTML>\n<HEAD><TITLE>Not Found</TITLE></HEAD>\n<BODY><H2>File " +
				tmpFileName + " not found...</H2></BODY>\n</HTML>\n";
		response.setHeader("Content-length", Integer.toString(msg.length()));
		out.print(msg);
	}

	if (true) {
		// For avoiding extra newline(s)
		return;
	}%>