<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
<%@page import="imagemed.layout.datasource.LDSRecord"%>
<%@page import="imagemed.layout.datasource.DBLDSRecord"%>
<%@page import="java.util.List"%>
<%@page import="java.util.StringTokenizer"%>
<%@page import="java.util.Enumeration"%>
<%@page import="imagemed.layout.datasource.pointer.FieldInstancePointer"%>
<%@page import="imagemed.layout.datasource.pointer.RecordPointer"%>
<%@page import="imagemed.layout.datasource.LayoutDescriptor"%>
<%@page import="imagemed.layout.LayoutPart"%>
<%@page import="java.util.Properties"%>
<%@page import="imagemed.scheduler.SchedulerInterface"%><%@page import="imagemed.layout.datasource.EntryLayoutFactory"%>
<%@page import="imagemed.layout.datasource.DBLayoutDataSource"%>
<%@page import="imagemed.layout.datasource.DBLDSEntry"%><%--
* Component: cases
*
* Description:
*
* Parameters :
*
*
* Last Updated     : $Author: rty $
* Update Date Time : $Date: 2014/04/16 17:50:20 $
* RCS File Name    : $RCSfile: makeLog.jsp,v $
* RCS Revision     : $Revision: 1.3 $
* Locked by        : $Locker:  $
* Symbolic name    : $Name:  $
* State            : $State: Exp $
*
-- %><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.types.flag.IMTypeur"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out );

	is.setNonCacheable();
	is.response.setContentType( "text/plain" );

	if ( !is.regOK() ) {
		is.out.print( "No right to use this page" );
		return;
	}

	String layout = is.imRequest.getVal( "cLayoutType" );
	if ( layout == null ) {
		is.out.print( "No layout type!" );
		return;
	}

	String action = is.imRequest.getVal( "cAction" );
	String info = is.imRequest.getVal( "cInfo" );


	DBLayoutDataSource dblds = null;
	DBLDSEntry entry = null;
	if ( LayoutDescriptor.isLayoutTypePACSStudyOrderOrReportType( layout ) ) {
		//WARNING: this study/PACSorder/Report stuff will not be able to log non-db (DICOM only) fields
		// in case of report nothing will come! only sutdyUID
		// because report is old-fashioned, no colids

		//first create the entry
		String studyUID = is.imRequest.getVal( "cStudyUID" );
		String table = IMEnvBase.getEnv( "STUDYTBL" );

		if ( studyUID == null || "".equals( studyUID ) ) {
	//in this case (new record) only values coming from the form are logged

	dblds = EntryLayoutFactory.getDefaultDBLDS( is, LayoutPart.STUDYLAYOUT );
	entry = new DBLDSEntry( dblds );
	LDSRecord rootRec = entry.addRecord( table, null );
	dblds.setEntry( entry );
		}
		else {
	dblds = new DBLayoutDataSource( is, null, table, "SYUI", studyUID );
	entry = new DBLDSEntry( dblds );
	dblds.setEntry( entry );
	entry.initFromExisting( studyUID );
		}


		//update the entry with the actual information from the form
		Enumeration<String> parNames = is.imRequest.getParameterNames();
		while ( parNames.hasMoreElements() ) {
	String parName = parNames.nextElement();
	if ( parName.startsWith( "qe_" ) ) {
		String colid = parName.substring( 3 ); //cut qe_
		List<String> rowIDs = entry.getRootRecord().m_rowID;
		if ( rowIDs != null ) {
	String rowID = rowIDs.get( 0 );
	Helper.DEBUG( "rowid:" + rowID );
	if ( rowID != null ) {
		FieldInstancePointer fp = new FieldInstancePointer( table, rowID, colid );
		String value = is.imRequest.getVal( parName );
		if ( value != null ) {
	entry.m_recordMap.get( new RecordPointer( fp.m_source, fp.m_rowIDs ) ).setValue( fp.m_sfieldID, value );
		}
	}
		}
	}
		}
	}
	else if ( LayoutDescriptor.isLayoutTypeSchedulerType( layout ) ) {
		//if scheduler page - dblayout-os

		//first create the entry
		dblds = EntryLayoutFactory.getDefaultDBLDS( is, layout );

		String entryName = request.getParameter( "cEntryName" );
		if ( entryName == null || "".equals( entryName ) ) {
	//in this case (new record) only values coming from the form are logged
	entry = new DBLDSEntry( dblds );
		}
		else {
	entry = DBLDSEntry.readFile( is, entryName, dblds, true );
		}

		dblds.setEntry( entry );

		//update the entry with the actual information from the form
		Enumeration<String> parNames = is.imRequest.getParameterNames();
		while ( parNames.hasMoreElements() ) {
	String parName = parNames.nextElement();
	if ( parName.startsWith( "qe_" ) ) {
		FieldInstancePointer fp = FieldInstancePointer.decomposeFormInputName( parName );
		if ( fp != null ) {
	String value = is.imRequest.getVal( parName );
	if ( value != null ) {
		entry.m_recordMap.get( new RecordPointer( fp.m_source, fp.m_rowIDs ) ).setValue( fp.m_sfieldID, value );
	}
		}
	}
		}

	}

	//	entry.initFromRequest(is.imRequest);

	//log from the entry
	Properties logFields = new Properties();
	logFields.setProperty( "0LAC", action );
	if ( info != null ) {
		String result = "";
		//replace |colid|value|  with value, if value is empty, get from dblds
		IMStringTokenizer st = new IMStringTokenizer( info, '|' );
		while ( st.hasMoreTokens() ) {
	String text = st.nextToken();
	result += text;
	if ( st.hasMoreTokens() ) {
		String colid = st.nextToken();
		String value = "";
		if ( st.hasMoreTokens() ) {
	value = st.nextToken();
		}
		if ( "".equals( value ) ) {
	try {
		value = dblds.getValue( colid );
	}
	catch ( Exception e ) {
		Helper.ERRORLOG( "Couldn't get value for info field '" + colid + "', problem:" + Helper.throwable2String( e ) );
	}
		}
		if ( value != null ) {
	result += value;
		}
	}
		}
		logFields.setProperty( "0LIN", result );
	}

	SchedulerInterface.makeLogFieldsForLayout( is, layout, null, logFields, dblds );
	SchedulerInterface.logIntoTable( is, logFields );

	is.out.print( "OK: Log successful " );

	return;
%>--%>