<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 ** Component: cases
 **
 ** Description:
 **  Handles the redictation process.
 **
 **  @param cGr               		Study Instance UID of study
 **  @param int0_sopiuid      		sopiuid of the interpretation to be redictated
 **  @param int0_typeid       		typeid of the interpretation to be redirected
 **  @param batch_approve_context	context to be updated and used in the backURL if we are called from batchApprove
 **  @param cIMLockID		 					lock ID of the study
 **  @param cOp										operation code ('Redictate')
 **
 ** $Author$
 ** $Date$
 **
 *
 *  RCS File Name    : $RCSfile$
 *  RCS Revision     : $Revision$
 *  Locked by        : $Locker$
 *  Symbolic name    : $Name$
 *  State            : $State$
-- %><%@
	page import = "imagemed.util.*, imagemed.exception.*,imagemed.http.*,java.util.*,java.sql.*,
			 imagemed.imsession.*, imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession(request, response, out);
  response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
	response.setHeader("Pragma","no-cache"); //HTTP 1.0
	response.setDateHeader ("Expires", -1); //prevents caching at the proxy server
	
  if (!is.regOK()) {
    return;
  }

  if (is.regRights.indexOf("R") == -1) {
		throw new IMException("You don't have the right to redictate reports");
	}
	
	String study = request.getParameter("cGr");
	String sopiuid = request.getParameter("int0_sopiuid");
	String typeid = request.getParameter("int0_typeid");
	String batchContext = request.getParameter("batch_approve_context");
	String reportBackURL = request.getParameter("cBack");
	String loginBackURL = "/cases/reportview.jsp?cGr="+study+"&cBack="+Helper.URLEncodeUTF8(reportBackURL);
	boolean shouldConfirm=false;
	
	if (!shouldConfirm) {
		// lock the study if needed...
		Properties prpLock = new Properties();
		IMLock.lockStudy(is, study, "CheckLock", prpLock);
		Helper.DEBUG("redictate.jsp", "IMLock.lockStudy(CheckLock) returned "+Helper.props2String(prpLock));
		if (!"OK".equals(prpLock.getProperty("IMLock"))) {
			IMLock.lockStudy(is, study, "Lock", prpLock);
			if (!"OK".equals(prpLock.getProperty("IMLock"))) {
				// locked by someone else...
				// how about breaking the lock?
				Helper.DEBUG("redirect.jsp", "the study is locked by someone else...");
				return;
			}
		}
		String lockID = prpLock.getProperty("IMLockID");
		if (lockID == null) {
			
		}
		Helper.DEBUG("redictate.jsp", ""+is.sessionVariables+" "+lockID);
		is.sessionVariables.setProperty("IMLockID", prpLock.getProperty("IMLockID"));
		ReportToolbox.doCorrect(is, study, sopiuid, typeid, true);
		if (batchContext != null && batchContext.length() > 0) {
			IMRequest imrTmp = new IMRequest(is);
			imrTmp.loadContext(batchContext);
			String[] parRPIDs = imrTmp.getVals("cRPID");
			Helper.writeTextFile("/tmp/redictate.jsp."+batchContext+".debug.txt", imrTmp.toString());
			String[] selectedRPIDs = imrTmp.getVals("cSelectedRPs");
  		String currentID = imrTmp.getVal("cCurrentID");
			List<String> rpidList = new ArrayList<String>();
			rpidList.addAll(Arrays.asList(parRPIDs));
			List<String> selRpidList = new ArrayList<String>();
			selRpidList.addAll(Arrays.asList(selectedRPIDs));
			int n = rpidList.indexOf(currentID);
			int newCurrentIndex = -1;
			if (n < rpidList.size()-1) {
				newCurrentIndex = n+1;
			}
			else if (n > 0) {
				newCurrentIndex = n-1;
			}
			if (newCurrentIndex > -1) {
				String newCurrent = rpidList.get(newCurrentIndex);
				imrTmp.setProperty("cCurrentID", newCurrent);
				rpidList.remove(currentID);
				imrTmp.setProperty("cRPID", rpidList.toArray(new String[0]));
				selRpidList.remove(currentID);
				imrTmp.setProperty("cSelectedRPs", selRpidList.toArray(new String[0]));
				imrTmp.save();
				
				ResultSet rs = IMEnv.getDB().createStatement().executeQuery("select SRCSTUDY,INTID from "+IMEnvBase.getEnv("REPORTTBL")+" where INTSOPIUID='"+newCurrent+"'");
				if (!rs.first()) {
					throw new IMException("Something nasty has happened around the database. (the reportpart "+newCurrent+" has disappeared)");
				}
				String newIntid = rs.getString("INTID");
				loginBackURL = "/cases/reportview.jsp?cContext="+batchContext+"&cOp=batchApprove&cGr="+study+
					"&cIntID="+newIntid+"#section_"+newIntid;
			}
			else { // last one of the batch oper is to be removed...
				loginBackURL = imrTmp.getVal("cBack");
				imrTmp.deleteContextFile();
			}
		}
		response.sendRedirect( GetpbsToolbox.getURLforGetpbs() + "?cDictate=true&cGr="+study+
			"&cLoginBack="+Helper.URLEncodeUTF8(loginBackURL));
	}
%>--%>