<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *  WEB interface for editing series data
 *
 *  @param cStudy        Study Instance UID
 *  @param cSeries       Series Instance UID
 *  @param cBack         URL to go back after editing  (goes back to Referer if missing)
 *  @param cBreak        The study/order is locked, break the lock
 *  @param cOp           Only accepted value is 'Save' = save changes
 *
 *   qe_..., qi_..., qo_..., qs_... parameters are auto generated and processed by Types classes
 *   and contains old and new values for study/order attributes.
 *
 * Last Updated     : $Author$
 * Update date/time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@page import="imagemed.exception.IMException"%>
<%@
	page import="java.util.*, java.io.*, java.sql.*, imagemed.imsession.*, imagemed.jsputil.*,
			imagemed.util.*, imagemed.types.string.*, imagemed.types.*, com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			imagemed.exception.*, imagemed.dcprocessing.EditStudy, imagemed.dicom.*, imagemed.types.flag.IMTypeur, java.text.Format"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession( request, response, out );
	String parStudy     = request.getParameter( "cStudy" );
	String parSeries    = request.getParameter( "cSeries" );
	String parBack      = request.getParameter( "cBack" );
	String parBreak     = request.getParameter( "cBreak" );

	String parUser = null;
	String editError = LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_EDIT_ERROR" );

	boolean isSave  = "Save".equals( request.getParameter( "cOp" ) );
	boolean isCancel = "Cancel".equals( request.getParameter( "cOp" ) );

	Syslog slog = new Syslog( "seriesEdit.jsp", 0 , IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
	Connection IMDB = IMEnv.getDB();
	String pageName = "/cases/seriesEdit.jsp";

	is.regDest = "/cases/index.jsp";
	if ( !is.regOK() ) {
		return;
	}

	String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
	if ( redirHost != null ) {
		String redirURL = redirHost + "/cases/seriesEdit.jsp?" + RedirectToolbox.getRedirectParams( is );
		response.sendRedirect( redirURL );
		return;
	}
	
	Defs casesDefs = new Defs( is, parUser );

%><%!

	static List<String> allEditColids = null;
	static {
		allEditColids = new ArrayList<String>();
		allEditColids.add( "SRNM" );
		allEditColids.add( "MODA" );
		allEditColids.add( "SRDT" );
		allEditColids.add( "SRDS" );
	}
	
	static IMTypePN typePN = (IMTypePN) IMType.getTypeFor( "PN" );

%><%boolean hasEditRight = is.hasRight( IMTypeur.EDIT_RIGHT );

	if ( null == parBack )
		parBack = request.getHeader( "Referer" );

	if ( null == parBack )
		parBack = "javascript:self.history.back();";


	// Check if the user has rights to edit studies and/or creating orders
	if ( ! hasEditRight ) {
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.SERIES, "edit" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.STUDY, parStudy );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, "no rights" );
		logEntry.log( slog, Syslog.LOG_ERR );

//		slog.syslog(Syslog.LOG_ERR, "ERROR SERIES edit " + casesDefs.getUser() + " - " + parStudy + " - - - - - - - - - - no_rights");
		Format[] msgFormat = new Format[] { null };
		Object[] msgObject = new Object[] { is.regID };
		throw new IMGeneralException( is,
				LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_SERIESEDIT_NO_RIGHTS", msgFormat, msgObject, true ),
				"cases/index.jsp", editError, parBack);
	}

	String leftFields[]  = { "SRNM","MODA" };
	String rightFields[] = { "SRDT","SRDS" };

	// List editable fields here:
	String fields[] = EditToolbox.addArrays( leftFields, rightFields );

	String StudyDir = RepositoryHandler.getLocation( RepositoryHandler.DATA, parStudy );

	// Get Report

	String pbrFileName = null;
	int nWaitTime = 30000; // 30 sec

	try {
		ResultSet rs = IMDB.prepareStatement( "select FNAME from " + IMEnvBase.getEnv( "OBJECTTBL" ) +
				" where STYIUID='" + parStudy + "' AND SOPCLUID='" + IMEnvBase.getEnv( "PBREPORT_SOPCLASS" ) + "'"
				).executeQuery();
		if ( rs.next() )
			pbrFileName = StudyDir + "/" + rs.getString( "FNAME" );
		rs.close();
	}
	catch ( SQLException sqlEx ) {
	}


	String SQLtables[] = { "Dcstudy", "Dcobject" };
	IMFieldManagerImpl fm = new IMFieldManagerImpl( "Dcfields", "Dctypes", SQLtables );

	TableDescriptorImpl tdesc = new TableDescriptorImpl();
	WorklistTableParamsImpl tparams = new WorklistTableParamsImpl( is.imRequest, casesDefs.getFilterUser() );
	tparams.setDefaults( "/cases/index.jsp", is );

	Properties filters = new Properties();
	filters.setProperty( "SYUI", parStudy );
	tparams.setFilters( filters );

	tdesc.setTableParams( tparams );
	tdesc.setFieldManager( fm );

	WorklistResultImpl result = new WorklistResultImpl( is, tdesc );
	result.setGlobal( true );
	if ( !result.next() || !result.isInAccessList( parStudy ) )
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_NO_SUCH_STUDY" ), "cases/index.jsp", editError, parBack );

	String patientName = IMTypePN.displayOrdinaryText( result.getValue( "PANM" ) );
	String logPatient = Syslog.logValue( patientName );
	String logModality = Syslog.logValue( result.getValue( "MODA" ) );
	String logStudyDate = Syslog.logValue( result.getValue("SYDT") );


	Properties logPrp = new Properties();
	logPrp.setProperty( "LOG_PATIENT", logPatient );
	logPrp.setProperty( "LOG_MODALITY", logModality );
	logPrp.setProperty( "LOG_STUDYDATE", logStudyDate );
	logPrp.setProperty( "LOG_PARTIAL", "series[1]" );

  /********************
   *   Save changes   *
   ********************/
	String saveHtml = null;
	MessageBox saveMessageBox = null;
	if ( isSave ) {
		Properties prp = null;

		try {
			Properties rspHeaders = new Properties();
			EditStudy editStudy = new EditStudy( parStudy, parSeries, slog, EditStudy.EditMode.DEFAULT );
			prp = editStudy.edit( fields, is, rspHeaders, logPrp );
			if ( prp != null ) {
				String disp = prp.getProperty( "DISPLAY", "" );
				
				Format[] msgFormat = new Format[] { null, null };
				Object[] msgObject = new Object[] { patientName, disp };
				
				saveHtml = "<H2><P>&nbsp;<P>" + LocalizedMessage.getCompoundMessage( "CASES_SERIESEDIT_YOU_MODIFIED_MSG", msgFormat, msgObject, true );
				saveHtml = saveHtml + "\n<Script language=\"JavaScript\">";
				saveHtml = saveHtml + "\n  needUnlock = 0;";
				saveHtml = saveHtml + "\n</Script>\n";
			}
			else {
				saveHtml = "";
				if ( "FAILED".equals( rspHeaders.getProperty( "IMLock" ) ) )
					saveHtml = "<H2><P><P>" + LocalizedMessage.getSimpleMessage( "CASES_EDIT_STUDYLOCK_STOLEN" ) + "</H2>";
				saveHtml = saveHtml + "<H3>" + LocalizedMessage.getSimpleMessage( "CASES_SERIESEDIT_STUDY_SERIES_HASNT_CHANGED" ) + ".</H3>";
				saveHtml = saveHtml + "\n<Script language=\"JavaScript\">";
				saveHtml = saveHtml + "\n  needUnlock = 1;";
				saveHtml = saveHtml + "\n</Script>\n";
			}
		}
		catch ( IMException imEx ) {
			String errMsg = imEx.getMessage();
			if ( errMsg == null )
				errMsg = LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_WHILE_SAVING_DATA" );
			else
				errMsg = "<BR>" + Helper.replace( errMsg, "\n", "<BR>" );
			throw new IMGeneralException( is, errMsg, "cases/index.jsp", editError, null );
		}
	} // Save

	if ( isCancel ) {
		IMLock.lockStudy( is, parStudy, "Unlock", new Properties() );
		response.sendRedirect( parBack );
		return;
	}

	Properties prpLock = new Properties();
	String lockID = null;
	boolean bLocked = false;
	boolean bMessageWindow = false;
	String  strMessageType = null;

	if ( !isSave ) {
		IMLock.lockStudy( is, parStudy, parBreak != null ? "Break" : "Lock", prpLock );

		
		bLocked = "OK".equals( prpLock.getProperty( "IMLock" ) );
		if ( bLocked) {
		lockID = prpLock.getProperty( "IMLockID" );
			if ( lockID == null ) {
				bLocked = false;
			}
		}

		if ( !bLocked ) {
			bMessageWindow = true;
			strMessageType = "true".equals( prpLock.getProperty( "IM_INTERRUPTED" ) ) ? "Interrupted" : "Break";
			if ( "UNEDITABLE".equals( prpLock.getProperty( "IMLock", "" ) ) )
			strMessageType = "UNEDITABLE";
		}
	} // !isSave%>
<%@page import="imagemed.dotcom.DotcomConfig"%><HTML>
<HEAD>
<TITLE>
	<% 
		String sb = LocalizedMessage.getSimpleMessage( "termSTUDY" );
		out.print( sb.substring(0,1).toUpperCase() + sb.substring(1).toLowerCase() );
	%>
</title>
<%

	if ( lockID == null )
		lockID = IMLock.getLockIDFromIS( is );

	if ( isSave ) {
%><META http-equiv="Refresh" content="3; URL=<%=parBack%>"><%
	}

	TabToolbox.writeIMpopup( is.out );
%>
<SCRIPT language="JavaScript">

	var needUnlock = 1; // in default unlock study when leaving page

	function unlockStudy() {
		if (needUnlock) {
			jsPopup('unlockwindow.jsp?study=<%=parStudy%>&cIMLockID=<%=lockID%>', 'unlockwindow');
		}
	}

	// used to submit edit form
	function submitEdit(frm, oper) {
		needUnlock = 0;  // in case of save study should not be unlocked
		frm.cOp.value = oper;
		frm.submit();
	}

	// used to submit break lock form
	function doSubmit(frm) {
		needUnlock = 0;  // in case of save study should not be unlocked
		frm.submit();
	}

</SCRIPT>
<%TableImpl.printCommonScript(is);%>
</head>

<BODY onUnload='unlockStudy()'>
<CENTER>
<%

	// Check if all of the objects in the study can be edited (storelevel is not 'Staged')
	EditToolbox.isStudyEditable( is, parStudy, patientName, parBack ); // Will throw an exception if study is uneditable

	String tab = "cases/index.jsp";

	TabToolbox.makeTabs( is, is.tabbean, tab, "White" );

	if ( isSave ) {
		if ( saveMessageBox != null ) {
			out.println( "<BR>" );
			saveMessageBox.print( is.out );
			out.println( "</center></body></html>" );
			return;
		}

		if ( saveHtml != null ) {
			out.println( saveHtml );
			out.println( "</center></body></html>" );
			return;
		}
	}


	if ( bMessageWindow ) {
		if ( "Modified".equals( strMessageType ) ) {
			throw new IMGeneralException( is,
					LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_STUDY_MODIFIED_HASNT_ARRIVED" ), 
					tab, editError, parBack );
		}
		else if ( "Interrupted".equals( strMessageType ) ) {
			throw new IMGeneralException( is,
					LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_CANT_LOCK_STUDY" ),
					tab, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_LOCK_UNAVAILABLE" ), parBack );
		}
		else if ( "UNEDITABLE".equals( strMessageType ) ) {
			// We should never get here, isStudyEditable will catch it before.
			// But for safe ...
			MessageBox box = new MessageBox( LocalizedMessage.getSimpleMessage( "GENERIC_UNEDITABLE" ), "60%" );
			
			Format[] msgFormat = new Format[] { null, null };
			Object[] msgObject = new Object[] { patientName, parStudy };
			box.setMessage( "<center><H2><BR>" + LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_EDIT_CANT_EDIT_STUDY_DISABLED", msgFormat, msgObject, true) + "</BR></BR></H2></center>" );
			//box.setMessage( "<center><H2><BR>Can't edit study of " + patientName + ".<BR><font size=-1>(" + parStudy +
			//			")</font><p> Editing this study is disabled on this server.</BR></BR></H2></center>" );
			box.addButton( new Button( parBack, "BUTTON_CANCEL", "BUTTON_CANCEL_TITLE" ) );
%>
<BR><%
	box.print( is.out );
		}
		else { // Break
	String lockerName = prpLock.getProperty( "IMLockOwner" );
	String lockAge = prpLock.getProperty( "IMLockAge" );
	lockerName = ( null == lockerName ) ? LocalizedMessage.getSimpleMessage( "GENERIC_ANOTHER_USER" ) : IMTypePN.displayOrdinaryText( lockerName );

	MessageBox box = new MessageBox( LocalizedMessage.getSimpleMessage( "GENERIC_LOCKED" ),"60%" );
	
	Format[] msgFormat = new Format[] { null , null };
	Object[] msgObject = new Object[] { lockerName, ReportToolbox.getLockAgeMessage(lockAge) };
	
	String lockMessage;
	if( is.hasRight( PacsRight.BreakLock.letterString()  ) ) {
		lockMessage = "STUDY_LOCK_LOCKED_BY";
	}
	else {
		lockMessage = "STUDY_LOCK_LOCKED_BY_NO_BREAK";
	}

	String msg = LocalizedMessage.getCompoundMessage( lockMessage, msgFormat, msgObject, true);
	box.setMessage( "<H2><BR>" + msg + "<BR><BR></H2>" );

	if( is.hasRight( PacsRight.BreakLock.letterString()  ) ) {
		box.addButton( new Button( "javascript:doSubmit(self.document.breakForm);","BUTTON_BREAK", "BUTTON_BREAK_TITLE" ) );
	}
	box.addButton( new Button( parBack, "BUTTON_CANCEL", "BUTTON_CANCEL_TITLE" ) );
%>
    <FORM action="<%= pageName %>" method=get name="breakForm">
<%
			box.print( is.out );

			if ( lockID != null ) {
%>
    <INPUT type="hidden" name="cIMLockID" value="<%=lockID%>">
<%
			}
			String referringHost = RedirectToolbox.getReferringHost( is );
			if ( referringHost != null && referringHost.length() > 0 ) {
%>
    <INPUT type="hidden" name="RefererHost" value="<%=referringHost%>">
<%
			}
			if ( is.isParentSession ) {
%>
    <INPUT type="hidden" name="ParentSession" value="<%=is._sid.substring(1)%>">
<%
			}
%>
    <INPUT type="hidden" name="cStudy" value="<%=parStudy%>">
    <INPUT type="hidden" name="cSeries" value="<%=parSeries%>">
    <INPUT type="hidden" name="cBack" value="<%=Helper.htmlEncode( parBack )%>">
    <INPUT type="hidden" name="cBreak" value="true">
    </FORM>
<%
		} // Break lock window
%>
    <script language="JavaScript">
      needUnlock = 0;  // study was not locked
    </script>
    </center></body></html>
<%
		return;
	} // Message Window

	// Get series level values from database and put to a Properties
	Properties prpDATA = new Properties();

	String seriesQuery = "select MIN(OMODALITY) as SMODY,  MIN(SERNUMBER) as SN," +
			" MIN(concat(SERDATE, '_', SERTIME)) as SDT, MAX(SERDESCR) as SDESCR from " + IMEnvBase.getEnv( "OBJECTTBL" ) +
			" where STYIUID='" +parStudy + "' AND SERIUID='" + parSeries + "'";
	ResultSet resSeries = IMDB.prepareStatement( seriesQuery ).executeQuery();
	if ( !resSeries.next() )
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_NO_SUCH_STUDY_SERIES" ), "cases/index.jsp", editError, parBack );

	String serNumber = resSeries.getString( "SN" );
	String serModality = resSeries.getString( "SMODY" );
	String serDateTime = resSeries.getString( "SDT" );
	String serDescr = resSeries.getString( "SDESCR" );
	
	if ( serNumber != null )
		prpDATA.setProperty( "SRNM", serNumber );
	if ( serModality != null )
		prpDATA.setProperty( "MODA", serModality );
	if ( serDateTime != null )
		prpDATA.setProperty( "SRDT", serDateTime );
	if ( serDescr != null )
		prpDATA.setProperty( "SRDS", serDescr );

	// --- Prepare editing ---
%>
  <TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
  <FORM method="post" name="editForm" action="seriesEdit.jsp">
  <TR><TD class=BgShadow width="100%">
  <TABLE border=0 cellpadding=0 cellspacing=0 width="100%"><TR>
  <TD class=BgShadow width="50%">
  <BR><font size=4>&nbsp;&nbsp;<%= LocalizedMessage.getCompoundMessage( "CASES_SERIESEDIT_EDIT_SERIES_OF", new Format[] { null }, new Object[] { patientName }, true) %></font><BR><BR>
  </TD>
  <TD class=BgShadow width="50%" align=right>
  &nbsp;
  </TD>
  </TR></TABLE></TD></TR>
  </TABLE>

  <TABLE border=1 cellpadding=0 cellspacing=0 width=100%>
<%
	String header = "";
	header += LocalizedMessage.getSimpleMessage( "GENERIC_FIELD" );
	header += ", ";
	header += LocalizedMessage.getSimpleMessage( "GENERIC_EDIT" );
	header += ", ";
	header += LocalizedMessage.getSimpleMessage( "GENERIC_FIELD" );
	header += ", ";
	header += LocalizedMessage.getSimpleMessage( "GENERIC_EDIT" );

	//out.write( Helper.header3D( "Field, Edit, Field, Edit" ) );
	out.write( Helper.header3D( header ) );

	try {
		Properties extraPar = new Properties();
		extraPar.setProperty( "StudyInstanceUID", parStudy ); // Editing comments (long values)

		for ( int i = 0; i < leftFields.length; i++ ) {
			String fld = leftFields[ i ];

			if ( fld == null ) {
        // Group break
%><TR><TD class=BgLight height=4 colspan=4>
      <img src="/cases/art/spacer.gif" height=4 border=none></TD></TR>
<%
				continue;
			}

			String value = prpDATA.getProperty( fld );
%>
  <TR>
  <TD class=BgMedDark><FONT size="2"><%= fm.getHeaderName( fld ) %></FONT><%
%>
</TD>
  <TD class=BgShadow nowrap><%

			fm.inputField( is, fld, value, extraPar );
			if ( EditToolbox.isSelect( fld ) )
				EditToolbox.printSelectButton( is, fld, "editForm", value, "select value from a list" );

%></TD><%

			String fld2 = rightFields[ i ];
			if ( null == fld2 ) {
%><TD class=BgShadow colspan=2 nowrap>&nbsp;</TD><%
			}
			else {
%>
  <TD class=BgMedDark><FONT size=2"><%= fm.getHeaderName( fld2 ) %></FONT></TD>
  <TD class=BgShadow nowrap><%
				String value2 = prpDATA.getProperty( fld2 );
				fm.inputField( is, fld2, value2, extraPar );
				if ( EditToolbox.isSelect( fld ) )
					EditToolbox.printSelectButton( is, fld2, "editForm", value2, "select value from a list" );
%></TD><%
			}
%>
  </TR>
<%
		}
%>
<TR>
 <TD class=BgShadow nowrap colspan=4 align=right>
  <BR>
  <table border=0 width="100%"><tr><td align=left>&nbsp; &nbsp; &nbsp; &nbsp;
	</td><td nowrap align=right>
<%

		Button saveButton = new Button( "javascript:submitEdit(self.document.editForm,'Save');", "BUTTON_SAVE", "BUTTON_SAVE" );
		saveButton.print( is.out );
%>&nbsp; &nbsp; &nbsp; &nbsp;<%
		Button cancelButton = new Button( "javascript:submitEdit(self.document.editForm,'Cancel');", "BUTTON_CANCEL", "BUTTON_CANCEL_TITLE" );
		cancelButton.print( is.out );
%>
  &nbsp; &nbsp; &nbsp; &nbsp;
  </TD></TR></TABLE>
  <%-- BR -- %>
 </TD>
</TR>
<TR>
  <TD colspan=4 class=FieldBlock></td>
</tr> </TABLE>
<%
	}
	catch ( Throwable th ) {
		is.out.println( "<!--" + Helper.throwable2String( th ) + "-->" );
	}
%>
<%-- <pre><%= result.getDebug() %></pre> -- %>
<input type=hidden name="cOp" value="">
<input type=hidden name=cIMLockID value="<%= Helper.htmlEncode( lockID ) %>">
<input type=hidden name=cStudy value="<%= Helper.htmlEncode( parStudy ) %>">
<input type=hidden name=cSeries value="<%= Helper.htmlEncode( parSeries ) %>">
<input type=hidden name=cBack value="<%= Helper.htmlEncode( parBack ) %>">
</form>
</body>
</html>
--%>