<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: main
 *
 * Sign on to eRAD/ImageMedical server
 *
 *   Login from the WEB page or from the viewer with userid/passwd
 * authentication. Session ID will be detected (from sessionid cookie), and
 * new sessionid will be created if no sessionid found. Successfull login will
 * return to the destination received in parameter.
 *
 * Parameters:
 *
 *  @param reg_dest          Return destination after successfull sign on
 *  @param reg_user          User ID
 *  @param reg_passwd        Password
 *  @param pwch              Change password after successfull login
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@
	page errorPage ="exceptionHandler.jsp"

%><%@
	page import="java.io.*, java.sql.*, imagemed.imsession.*, imagemed.exception.*,
			imagemed.util.*, imagemed.jsputil.*, java.text.*"

%><%

	Helper.DEBUG( "login.jsp runs!" );
	IMSession is = new IMSession( request, response, out );
	is.bRegNotNeeded = true;
	if ( !is.regOK() ) {
		Helper.DEBUG( "login.jsp regok is false!" );
		return;
	}
	Helper.DEBUG( "login.jsp regok OK" );

	if ( ( new File( IMEnvBase.getEnv( "LOGIN_DISABLED_FLAG" ) ) ).exists() ) {
		throw new IMLoginDisabledException();
	}

	//boolean isLdap = LdapToolbox.isLdap();

	// Input Parameters

	String parDest = request.getParameter( "reg_dest" );
	String parPassword = request.getParameter( "reg_passwd" );
	String parRegUser = request.getParameter( "reg_user" );
	String parLocation = request.getParameter( "reg_loc" ); //this may be null here, and modified later in this code!
	
	Helper.DEBUG( "login.jsp reguser:" + parRegUser + " ,dest:" + parDest + " ,Location:" + parLocation );
	
	String parChangePw = request.getParameter( "pwch" );
	if ( null == parRegUser ) {
		parRegUser = "";
	}
	
	boolean staticUser = IMSession.isStatic( parRegUser );
	parRegUser = parRegUser.replace( ' ' , '_' );

	String sid = is.COOKIE.getProperty( RequestConsts.COOKIE_SESSION_ID_NAME );

	Statement st = IMEnv.getDB().createStatement();
	ResultSet rs;
	// Login tmp can be removed by daily cleanup if there was no
	// login to the server for some days, so we should make sure
	// the login tmp directory exists, and we should create it
	// if doesn't exist.
	File loginTmp = new File( IMEnvBase.getEnv( "LOGIN_TMP" ) );
	if ( !loginTmp.exists() ) {
		loginTmp.mkdir();
	}

	String errfname = IMEnvBase.getEnv( "LOGIN_TMP" ) + "/" + is.regIP + ".err";
	File errFile = new File( errfname );

	boolean bIsViewer = false;
	String strUserAgent = request.getHeader( "user-agent" );
	String strViewerAgent = request.getHeader( "vieweragent" );
	if ( null != strUserAgent ) {
		bIsViewer = ( -1 != strUserAgent.indexOf( "PracticeBuilder" ) || (strViewerAgent != null && -1 != strViewerAgent.indexOf( "pbuilder.exe" ) ) );
	}

	//check and logIn

	try {
		boolean isLdap = IMAdminToolbox.verifyPasswordAndRestriction( is, parRegUser, parPassword );

		// Picking up start page if not yet set
		if ( staticUser ) {
			parDest ="/imadmin/users.jsp";
		}
		else if ( parDest == null || parDest.length() == 0 ) {
			parDest = TabToolbox.getDefaultPageURL( parRegUser );
		}

		
		// Checking if the password is still valid, or should be changed
		if ( !isLdap && "true".equals( parChangePw ) ) {
			// Changing password
			is.setRegID( parRegUser );
			String errmsg  = PasswordToolbox.changePassword( is );
			if ( errmsg != null ) {
				// An error occured while changing password
				PasswordToolbox.writeChangePasswordForm( is, parRegUser, parPassword, null, null, errmsg, parDest );
				return;
			}
		}
		else if ( !( staticUser || isLdap ) ) {
			// Report login to Password Manager
			PasswordManager pm = new PasswordManager( parRegUser );
			pm.login();

			// we should check for passwordstatus here
			if ( pm.getPasswordStatus() != PasswordManager.PWSTATUS_OK ) {
				String title = LocalizedMessage.getSimpleMessage( "LOGIN_PASSWORD_EXPIRED_TITLE" );
				String message = LocalizedMessage.getSimpleMessage( "LOGIN_PASSWORD_EXPIRED_MESSAGE" );
				if ( pm.getPasswordStatus() == PasswordManager.PWSTATUS_INVALID_FIRST_TIME ) {
					message = title = LocalizedMessage.getCompoundMessage( "LOGIN_FIRST_TIME_NEW_PASSWORD_MESSAGE",  new Format[] { null }, new Object[] { IMEnvBase.getEnv("PRODUCT_NAME") }, true );
					title = LocalizedMessage.getCompoundMessage( "LOGIN_FIRST_TIME_NEW_PASSWORD_TITLE",  new Format[] { null }, new Object[] { IMEnvBase.getEnv("PRODUCT_NAME") }, true );
				}
				PasswordToolbox.writeChangePasswordForm( is, parRegUser, parPassword, message, title, null, parDest );
				return;
			}
		}


		
		if ( null == sid ) {
			//it would have been nice to keep the already existing session id if
			//any, but it would be able
			//for the same user to work from two locations simultaneously, or for
			//multilpe users to work using the same user name and password

			if (parDest != null ) {
				parDest = parDest + ( parDest.indexOf('?') == -1 ? "?r_setc=true" : "&r_setc=true" ) ;
			}
		}

		parLocation = LocationToolbox.getUpdatedLocationID( parRegUser, parLocation );
		Helper.DEBUG( "modified location:" + parLocation );

		String parTimeZone = IMSession.calculateTimeZone(parRegUser, parLocation);
		is.loginUser( parRegUser, null, parLocation, parTimeZone );
		
		if ( errFile.exists() ) {
			errFile.delete();
		}

		LocationToolbox.logged( parRegUser, parLocation );

		if ( bIsViewer ) {
			response.setHeader( "IMRegRights", is.regRights );
%><HTML><HEAD></HEAD><BODY>OK</BODY></HTML><%
		}
		else {
			Helper.DEBUG( "redirecting:" + parDest );
			response.sendRedirect( parDest );
			return;
		}
		//endOf try check and logIn
	}
	catch( SQLException exSQL ) {
		Helper.DEBUG( "login.jsp", "SQLException cought " + Helper.throwable2String( exSQL ) );
	}
	catch( Throwable t ) {
		// count the number of failed attempts from a host
		String reason = t.getMessage();

		if ( "".equals( parPassword ) && reason.indexOf( "password" ) != -1  ) {
			//Sticky Enter (probably) => Don't send mail! & Don't record anything!
		}
		else {
			boolean append = true;
			long modTime = 0;
			if ( errFile.exists() ) {
				modTime = errFile.lastModified();
				long now = System.currentTimeMillis();
				boolean bOneHour = ( now - modTime < 3600000 );
				int nLF = 0;
				try ( FileInputStream errInStream = new FileInputStream( errfname ) ) {
					byte[] bytes = new byte[ 1024 ]; // probably its enough for free attempt
					int nBytes = errInStream.read( bytes );
					//counting new lines (number of attemts)
					if ( nBytes != -1 ) {
						for ( int i = 0; i < bytes.length; i++ ) {
							if ( bytes[ i ] == '\n' ) {
								nLF++;
							}
						}
					}
				}

				// It's the third (or more) attempt in the last one hour
				if ( nLF >= 2 && bOneHour ) {
					append = false;
					modTime = 0;
					try ( FileOutputStream errorFlag = new FileOutputStream( IMEnvBase.getEnv( "DRWATSON_WARNING_FILE" ), true ) ) {
						String strThirdAttempt = "3rd login attempt failed: " + is.regIP + " " + parRegUser + "\n";
						errorFlag.write( strThirdAttempt.getBytes() );
					}
				}
				else if ( !bOneHour ) {
					// the last append was more then one hour ago
					append = false;
					modTime = 0;
				}
			} // if errFile.exists()

			try ( FileOutputStream fErrStream = new FileOutputStream(IMEnvBase.getEnv( "LOGIN_TMP" ) + "/" + is.regIP + ".err", append ) ) {
				String strError = parRegUser + " ";
				if( reason != null ) {
					strError += reason + "\n";
				}
				else {
					strError += Helper.throwable2String( t );
				}
				fErrStream.write( strError.getBytes() );
			}
			if ( modTime != 0 ) {
				errFile.setLastModified( modTime );
			}

			Syslog logger = new Syslog( "login", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );
			String logMsg = parRegUser + " login failed [" + is.regIP + "]";
			logger.syslog( Syslog.LOG_ERR, logMsg );
		} // failed login attempt

		response.setHeader( "IMAuthentication", "failed" );

		LogForm.writeLogForm( is, LocalizedMessage.getSimpleMessage( "LOGIN_FAILED" ), parDest );
	} // catch Throwable
	
	return;
%>--%>